// compito.cpp
#include "debug_Ristorante.h"

Ristorante :: Ristorante (int n){
	
	if(n<=0)
		dim = - n + 1;
	
    dim = n;
    lista = new elem;
    lista = nullptr;
    postiliberi = dim;
} 

void Ristorante::aggiungi(char* s, int n){
    if (postiliberi >= n && lista == nullptr){

        postiliberi -= n;

        return;
	}

	insCoda (lista, s, n);
}

void Ristorante::insCoda(elem*& L, char *s, int n){

    if(L == nullptr){
        elem*q = new elem;
        q-> persone = n;
        strcpy(q->nome, s);
        L = q;
        q->pun = nullptr;

        return;
    }


    elem* q= L;
    while (q->pun != nullptr)
		q=q->pun;

    elem*r = new elem;
    r->persone = n;
    strcpy(r->nome, s);
    q->pun = r;

    return;
}

ostream& operator << (ostream& os, const Ristorante& R){

    if (R.postiliberi == R.dim){
        cout << "Posti liberi " << R.dim << ", in attesa nessuno" << endl;
        return os;
    }

    cout << "Posti liberi " << R.postiliberi << ' ';
    cout << "in attesa, ";

    for (elem* q = R.lista; q != nullptr; q = q-> pun){
        cout << q->nome << " ("<< q-> persone << " persone), "; 
    }

    cout << endl;

    return os;
}

Ristorante& Ristorante::operator -=(int n){

    postiliberi += n;

    if (lista->persone <= postiliberi){
        postiliberi -= lista->persone;
        delTesta(lista);            
    }

    return *this;
}

void Ristorante::delTesta(elem*& L){
    if (L == nullptr)
        return;

    if (L->pun == nullptr){
        L = nullptr;
        return;
	}

    elem* q=L;
    L = L->pun;
    delete q;
}

void Ristorante::elimina(elem*& L, char*s){
    if (strcmp(L->nome, s) == 0)
        delTesta(L);
        return;

    elem* prec = L;  
    elem* q = L->pun;

    for (; strcmp(q->nome, s) != 0 && q != nullptr; q = q->pun)
        prec=q;

    prec = q->pun;
    delete q;
}

bool Ristorante::rinuncia(char* cg){
    elem* p = lista;
    elem* q;     
    
	while(p != nullptr){
        if(strcmp(p->nome, cg) == 0){
            
            if (p == lista){
                lista = lista->next;
                delete p;
                p = lista;
                q = p;
            }

            else{ 
                q->next = p->next;
                delete p;
                q = q->next;
                p = q;
            }
                    
	        return true;            
        }

        q = p;
        p = p->next;
    }
	return false;
}

Ristorante::Ristorante(Ristorante& g){
	liberi = g.liberi;
	lista = nullptr;
	elem* coda = nullptr;

	for(elem** p = g.testa; p != nullptr; p = p->succ){
		elem** q = new gruppo;    
		strcpy(q->nome, p->nome);
		q->num = p->num;
		q->succ = nullptr;

		if(coda == nullptr)
			lista = q;
		else
			coda->succ = q;

		coda = q;
	}
}

void Ristorante::dealloca(elem*& L){
    if (L == nullptr)
            return;
    
	elem* prec = L;
    elem* q = prec->pun;

    for (; q != nullptr; q = q->pun){
        prec = q->pun;
        delete q;
        q = prec;
    }
}

Ristorante::~Ristorante (){
    dealloca(lista);
}
